(ns attendant.main
  (:require
   [com.stuartsierra.component :as component]
   [attendant.server :as server]
   [attendant.nrepl-component :as nrepl])
  (:gen-class))

(def port 2424)

(def nrepl-port 7288)

(defonce system
  (atom nil))

(defn main-system [& {:keys [dev]}]
  (component/system-map
   :server (server/map->Server {:port port
                                :dev dev})
   :nrepl (nrepl/map->NreplServer {:port nrepl-port})))

(defn -main []
  (println "starting main system")
  (reset!
   system
   (component/start
    (main-system))))

(comment
  "to restart the server component in-flight; presumably to update the middleware:"
  (swap! system assoc :server (component/stop (:server @system)))
  (swap! system assoc :server (component/start (server/map->Server {:port port}))))
